﻿//Box2D_06_02.as
package {
	//▼インポート
	import flash.display.Sprite;
	import flash.display.SimpleButton;
	import Box2D.Collision.b2AABB;
	import Box2D.Common.Math.b2Vec2;
	import Box2D.Dynamics.b2World;
	import Box2D.Dynamics.b2BodyDef;
	import Box2D.Collision.Shapes.b2PolygonDef;
	import Box2D.Dynamics.b2Body;
	import Box2D.Dynamics.b2DebugDraw;
	import Box2D.Collision.Shapes.b2MassData;
	import flash.events.Event;

	public class Box2D_06_02 extends Sprite {
		//▼定数定義
		//1mを表すピクセル数
		private static const DRAW_SCALE:Number = 100;
		//▼プロパティ定義
		private var _world:b2World;
		private var _bBox:b2Body;
		//▼コンストラクタ定義
		public function Box2D_06_02() {
			//▼物理エンジンのセットアップ
			//物理エンジン適用範囲の設定（ステージの100ピクセル外側）
			var worldRegion:b2AABB = new b2AABB();//矩形作成
			worldRegion.lowerBound.Set(-1, -1);
			worldRegion.upperBound.Set(6.5, 5);
			//重力の設定
			var gravity:b2Vec2 = new b2Vec2(0, 9.8);
			//範囲・重力・スリープの有無を指定して物理ワールドを作成
			_world = new b2World(worldRegion, gravity, true);
			
			//▼床（静体）の生成
			//BodyDefの設定
			var bdFloor:b2BodyDef = new b2BodyDef();
			bdFloor.position.Set(5.5 / 2, 3);
			//ShapeDefの設定
			var pdFloor:b2PolygonDef = new b2PolygonDef();
			pdFloor.SetAsBox(2, 0.15);
			//ボディの生成
			var bFloor:b2Body = _world.CreateBody(bdFloor);
			bFloor.CreateShape(pdFloor);
			
			//▼箱（動体）の生成
			var bdBox:b2BodyDef = new b2BodyDef();
			bdBox.position.Set(5.5 / 2, 1);
			
			/*****b2BodyDef.angleプロパティの設定****/
			bdBox.angle = Math.PI / 180 * 30;
			
			//ShapeDefの設定
			var pdBox:b2PolygonDef = new b2PolygonDef();
			pdBox.SetAsBox(0.3, 0.2);
			pdBox.density = 1;//密度（1平方メートルあたりの重量（kg））
			pdBox.restitution = 0.5;//反発係数（通常0～1）
			//ボディの生成
			_bBox = _world.CreateBody(bdBox);
			_bBox.CreateShape(pdBox);
			//質量の設定
			_bBox.SetMassFromShapes();

			//▼描画設定
			var dd:b2DebugDraw = new b2DebugDraw();
			dd.m_sprite = this;
			dd.m_drawScale = DRAW_SCALE; //1mを100ピクセルにする
			dd.m_fillAlpha = 0.3; //塗りのアルファ値
			dd.SetFlags(b2DebugDraw.e_shapeBit);//物体を表示する設定に
			_world.SetDebugDraw(dd);//物理ワールドにセット
			
			//▼イベントリスナーの追加
			addEventListener(Event.ENTER_FRAME, _enterFrameHandler);
		}
		
		//▼イベントリスナー定義
		private function _enterFrameHandler(eventObj:Event):void {
			_world.Step(1 / 24, 10);//物理シミュレーションの更新
		}
	}
}